Subject: Re: Efficient way to import snapshots?

From: Theodore Tso <[email-masked]>
Date: Tue, 31 Jul 2007 00:23:47 -0400

On Mon, Jul 30, 2007 at 06:44:13PM -0700, Linus Torvalds wrote:
> > 1st or maybe 2nd-gen Willamette CPU
> > 512MB memory (stupid motherboard that won't accept more)
> > Slow disks in RAID-5 configuration
> > Running ZFS with less than half of the recommended minimum memory, to
> > the point where I had to reduce the number of vnodes that the kernel is
> > allowed to cache to avoid running out of KVA
> 
> Oh, ok. Solaris.
> 
> With slow pathname lookup, and hard limits on the inode cache sizes.
> 
> Git really normally avoids reading the data, so even in 512M you should 
> _easily_ be able to cache the metadata (directory and inodes), which is 
> all you need. But yeah, Linux will probably do that a whole lot more 
> aggressively than Solaris does.

I also have a suspicion that ZFS's "never overwrite metadata" is
causing its inodes to be be scattered all over the disk, so the lack
of cacheing is hurting even more than it would for other filesystems.
(Put another way, there's probably a really good reason for ZFS's
minimum memory recommendations.)

Craig, it might be interesting to see what sort of results you get if
you use UFS instead of ZFS in your low-memory constrained
environment...

						- Ted